/**********************************************************************
  ELFt@C[hR}h
  $Id: eload_cmd.c,v 1.4 2003/07/06 01:37:03 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"

struct ELOAD_STATE{
  int mode ;
} ;
#define MODE_ELOAD 0
#define MODE_EINFO 1

int  eload_parse_opt(struct GETOPT_ARG *args, struct ELOAD_STATE *el_stat) ;
void eload_print_help() ;

int eload_cmd( struct GETOPT_ARG *args , int mode )
{
  int res ;
  int id ; 
  int ret ;
  struct ELOAD_STATE el_stat ;
  
  ret=eload_parse_opt(args,&el_stat) ;
  if( ret<0 ) return(NORMAL_EXIT) ;
  
  id=proc_list.cur_id ;
  
  if( XGETOPT_REFAGCP(args)<2 ){
    SYSMSG("Too few argument(s)\n") ;
    return(SPECIFY_ERROR) ;
  }
  
  if( el_stat.mode==MODE_ELOAD ){
    res=elf_load(  &proc_list.proc[id], XGETOPT_REFARGP(args,1) ) ;
    if( res != NORMAL_EXIT ){
      SYSMSG("Failed to load ELF file(%s)\n",XGETOPT_REFARGP(args,1)) ;
      return(FILE_OPEN_ERROR) ;
    }
  }else if( el_stat.mode==MODE_EINFO ){
    res=elf_info(  &proc_list.proc[id], XGETOPT_REFARGP(args,1) ) ;
    if( res != NORMAL_EXIT ){
      SYSMSG("Failed to load ELF file(%s)\n",XGETOPT_REFARGP(args,1)) ;
      return(FILE_OPEN_ERROR) ;
    }
  }
  return(NORMAL_EXIT) ;
  
}


int eload_parse_opt(struct GETOPT_ARG *args, struct ELOAD_STATE *el_stat)
{
  static struct GETOPT_LIST getopt_list[]={
    {"info",               'i',  NONARG, 'i'},
    {"help",               'h',  NONARG, 'h'},
    { NULL,               '\0',       0,'\0'} /*** terminator ***/
  } ;
  int ret ;

  el_stat->mode=MODE_ELOAD ;
  
  while(-1){
    ret=xgetopt(args, getopt_list) ;
    if( ret==XGETOPT_PARSE_COMPLETE ) break ;
    switch(ret){
    case 'h' :
      eload_print_help() ;
      return(-1) ;
      break ;
    case 'i' :
      el_stat->mode=MODE_EINFO ;
      break ;
    case XGETOPT_INVALID_OPTION :
      SYSERR("Invalid option %s\n",xgetopt_err) ;
      return(-1) ;
      break ;
    case XGETOPT_ARG_NOT_FOUND :
      SYSERR("Illegal arg for option %s\n",xgetopt_err) ;
      return(-1) ;
      break ;
    case XGETOPT_NOT_OPTION :
      break ;
    default :
      SYSERR("xgetopt internal error\n") ;
      return(-1) ;
    }
  }
  return(0) ;
}


void eload_print_help()
{
  SYSERR(
	 "Load ELF format file\n"
	 "Usage: eload [options] file\n"
	 " Options\n"
	 "  -i or --info : Print ELF file infomation.\n"
	 "  -h or --help : Print this help.\n"
	 "\n"
	 "     ELF`st@C݂̃vZXɃ[h܂B\n"
	 "     -i IvVw肷 ELF`st@C̏\\sȂ܂B\n"
	 ) ;
}
